package com.perforce.hws.route;

import com.perforce.hws.core.p4base.AuthMethods;
import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hwsclient.models.LoginResponse;
import spark.Request;
import spark.Response;

/**
 *
 */
public interface ProvidesLoginRoute extends AuthMethods, HasGson, ModelConversion {

    default Object handleLoginResponse(LoginResponse loginResponse, Request request, Response response) {
        String acceptHeader = request.headers("Accept");
        if (acceptHeader != null && acceptHeader.contains("text/plain")) {
            request.attribute("response_content_type_set", "true");
            response.header("Content-Type", "text/plain");
            response.header("Content-Length", Integer.toString(loginResponse.getTicket().getBytes().length));
            return loginResponse.getTicket();
        } else {
            return gson.toJson(loginResponse);
        }
    }
}
