package com.perforce.hws.utils;

import org.junit.Assert;
import org.junit.Test;

/**
 * Created by pallen on 10/08/2016.
 */
public class testP4dConfig {

	@Test
	public void testRsh() {
		P4dConfig config = new P4dConfig();
		config.setP4PORT("rsh:p4d -r root -L log -i");
		Assert.assertEquals("RSH test", "p4jrsh://p4d -r root -L log -i --java", config.toURIString());
	}

	@Test
	public void testSsl() {
		P4dConfig config = new P4dConfig();
		config.setP4PORT("ssl:localhost:1666");
		Assert.assertEquals("SSL test", "p4javassl://localhost:1666", config.toURIString());
	}

	@Test
	public void testTcp() {
		P4dConfig config = new P4dConfig();
		config.setP4PORT("tcp:localhost:1666");
		Assert.assertEquals("TCP test", "p4java://localhost:1666", config.toURIString());
	}

	@Test
	public void testHost() {
		P4dConfig config = new P4dConfig();
		config.setP4PORT("localhost:1666");
		Assert.assertEquals("Host test", "p4java://localhost:1666", config.toURIString());
	}

	@Test
	public void testPort() {
		P4dConfig config = new P4dConfig();
		config.setP4PORT("1666");
		Assert.assertEquals("Port test", "p4java://localhost:1666", config.toURIString());
	}
}
